BUSYBOX_VERSION:=1.3.2
BUSYBOX_BUILD_DIR:=$(LINUX_DIR)/busybox-$(BUSYBOX_VERSION)
BUSYBOX_SOURCE:=busybox-$(BUSYBOX_VERSION).tar.bz2
BUSYBOX_SITE:=http://www.busybox.net/downloads
BUSYBOX_CONFIG_FILE:=$(LINUX_DIR)/busybox.config
BUSYBOX_PATCH_FILE:=$(LINUX_DIR)/busybox.patch

$(DL_DIR)/$(BUSYBOX_SOURCE):
	wget -P $(DL_DIR) $(BUSYBOX_SITE)/$(BUSYBOX_SOURCE)

$(BUSYBOX_BUILD_DIR)/.unpacked: $(DL_DIR)/$(BUSYBOX_SOURCE)
	@-rm -rf $(BUSYBOX_BUILD_DIR)
	bzcat $(DL_DIR)/$(BUSYBOX_SOURCE) | tar -C $(LINUX_DIR) -xf -
	patch -p1 -d $(BUSYBOX_BUILD_DIR) <$(BUSYBOX_PATCH_FILE)
	touch $(BUSYBOX_BUILD_DIR)/.unpacked

$(BUSYBOX_BUILD_DIR)/.config: \
	    $(BUSYBOX_BUILD_DIR)/.unpacked $(BUSYBOX_CONFIG_FILE)
	cp $(BUSYBOX_CONFIG_FILE) $(BUSYBOX_BUILD_DIR)/.config
	make -C $(BUSYBOX_BUILD_DIR) oldconfig

$(BUSYBOX_BUILD_DIR)/busybox: $(BUSYBOX_BUILD_DIR)/.config                      
	make -C $(BUSYBOX_BUILD_DIR) CC="$(CC)"

busybox: $(BUSYBOX_BUILD_DIR)/busybox

busybox-clean:
	make -C $(BUSYBOX_BUILD_DIR) clean

busybox-dirclean:
	-rm -rf $(BUSYBOX_BUILD_DIR)

.PHONY: busybox busybox-clean busybox-dirclean
