DBST_DIR := $(TOPDIR)/debootstrap
DBST_CUST_DIR := $(DBST_DIR)/custom
DBST_TARGET_DIR := $(DBST_DIR)/target
DBST_EXCLUDE := aptitude,apt-utils,cpio,libdb4.4,libncursesw5,libsigs++-2.0-0c2a,nano,tasksel,tasksel-data

$(DL_DIR)/.downloaded-debs:
	debootstrap --download-only \
	    --exclude=$(DBST_EXCLUDE) $(SUITE) $(DL_DIR) $(MIRROR)
	touch $(DL_DIR)/.downloaded-debs

$(DBST_DIR)/.debootstraped: $(DL_DIR)/.downloaded-debs
	-rm -rf $(DBST_TARGET_DIR)
	mkdir -p $(DBST_TARGET_DIR)
	cp -a $(DL_DIR)/var $(DBST_TARGET_DIR)
	debootstrap --exclude=$(DBST_EXCLUDE) $(SUITE) $(DBST_TARGET_DIR) $(MIRROR)
	$(DBST_DIR)/scripts/customize
	cp -af $(DBST_CUST_DIR)/* $(DBST_TARGET_DIR)/
	touch $(DBST_DIR)/.debootstraped
	@#clear
	@echo
	@echo 'Now it is time to install the resulting directory tree to flash.'
	@echo
	@echo 'I assume that you have a Compact Flash card or a Disk-on-Module'
	@echo 'in some IDE controller, and that it has two ext2 formatted partitions,'
	@echo 'one for /boot and the second one for the rest of the system.'
	@echo 'Check that you have entered the right devices in the Config file.'
	@echo
	@echo 'Then you can run make install. After that you can move your flash'
	@echo 'card to another IDE controller and hopefully boot from there.'

debootstrap: $(DBST_DIR)/.debootstraped

debootstrap-clean: debootstrap-dirclean

debootstrap-dirclean:
	-rm -rf $(DBST_TARGET_DIR)

.PHONY: debootstrap debootstrap-clean debootstrap-dirclean
