LINUX_SOURCE:=linux-$(LINUX_VERSION).tar.bz2
LINUX_FULL_VERSION:=$(LINUX_VERSION)-$(LINUX_LOCAL_VERSION)
LINUX_DIR:=$(TOPDIR)/linux
LINUX_BUILD_DIR:=$(LINUX_DIR)/linux-$(LINUX_VERSION)
LINUX_INITRAMFS_SOURCE:=$(LINUX_DIR)/initramfs
LINUX_INITRAMFS_TARGET:=$(LINUX_BUILD_DIR)/initramfs
LINUX_CONFIG_FILE=linux.config
LINUX_DEB_FILE=linux-$(LINUX_FULL_VERSION)_$(LINUX_FULL_VERSION)_i386.deb

include $(LINUX_DIR)/busybox.mk

$(DL_DIR)/$(LINUX_SOURCE):
	wget -P $(DL_DIR) $(LINUX_SITE)/$(LINUX_SOURCE)

$(LINUX_BUILD_DIR)/.unpacked: $(DL_DIR)/$(LINUX_SOURCE)
	@-rm -rf $(LINUX_BUILD_DIR)
	bzcat $(DL_DIR)/$(LINUX_SOURCE) | tar -C $(LINUX_DIR) -xf -
	touch $(LINUX_BUILD_DIR)/.unpacked

$(LINUX_BUILD_DIR)/.config: \
	    $(LINUX_BUILD_DIR)/.unpacked $(LINUX_DIR)/$(LINUX_CONFIG_FILE)
	cp $(LINUX_DIR)/$(LINUX_CONFIG_FILE) $(LINUX_BUILD_DIR)/.config
	echo "-$(LINUX_LOCAL_VERSION)" >$(LINUX_BUILD_DIR)/localversion.router
	make -C $(LINUX_BUILD_DIR) oldconfig

$(LINUX_DIR)/$(LINUX_DEB_FILE): $(LINUX_BUILD_DIR)/.config \
		$(LINUX_INITRAMFS_SOURCE) $(BUSYBOX_BUILD_DIR)/busybox
	@-rm -rf $(LINUX_INITRAMFS_TARGET)
	cp -a $(LINUX_INITRAMFS_SOURCE) $(LINUX_BUILD_DIR)
	install -m 0755 $(BUSYBOX_BUILD_DIR)/busybox \
	    $(LINUX_INITRAMFS_TARGET)/bin/busybox
	make -C $(LINUX_BUILD_DIR)
	INSTALL_MOD_PATH=$(LINUX_INITRAMFS_TARGET) \
		make -C $(LINUX_BUILD_DIR) modules_install
	find $(LINUX_INITRAMFS_TARGET)/lib/modules/$(LINUX_FULL_VERSION)/kernel \
		-depth -regex '.*/kernel\(\|/drivers\(\|/scsi.*\|/usb.*\)\)' \
		-o -exec rm -rf {} \;
	make -C $(LINUX_BUILD_DIR) deb-pkg

linux: $(LINUX_DIR)/$(LINUX_DEB_FILE)

linux-clean: busybox-clean
	make -C $(LINUX_BUILD_DIR) clean
	-rm -rf $(LINUX_INITRAMFS_TARGET)
	rm -f $(LINUX_DIR)/$(LINUX_DEB_FILE)

linux-dirclean: busybox-dirclean
	rm -rf $(LINUX_BUILD_DIR)
	rm -f $(LINUX_DIR)/$(LINUX_DEB_FILE)

.PHONY: linux linux-clean linux-dirclean
